<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="供应商" prop="supplierId" v-if="ifAlone==null">
        <el-input
          v-model="queryParams.supplierId"
          placeholder="请输入供应商"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="姓名" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入姓名"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="职务" prop="position">
        <el-input
          v-model="queryParams.position"
          placeholder="请输入职务"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="电话" prop="telephone">
        <el-input
          v-model="queryParams.telephone"
          placeholder="请输入电话"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button v-if="!isDetail"
          type="primary"
          plain
          @click="openForm('create')"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button v-if="!isDetail"
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="供应商" align="center" prop="supplierId" >
        <template #default="scope">
          <span>{{ supplierList.find((item) => item.id === scope.row.supplierId)?.name }}</span>
        </template>
      </el-table-column>
      <el-table-column label="姓名" align="center" prop="name" />
      <el-table-column label="职务" align="center" prop="position" />
      <el-table-column label="电话" align="center" prop="telephone" />
      <el-table-column label="邮箱" align="center" prop="email" />
      <el-table-column label="负责的产品/业务模块" align="center" prop="productIds" >
        <template #default="scope">
          <span>{{ productList.find((item) => item.id === scope.row.productIds)?.name }}</span>
        </template>
      </el-table-column>
<!--      <el-table-column label="联系人负责的产品/业务模块" align="center" prop="productNames" />-->
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="操作" v-if="!isDetail" align="center" min-width="120px">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"

          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"

          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <ContactForm ref="formRef" :supplierId="{ receivedParam }" :ifAlone="ifAlone" @success="getList" />
  <el-form v-if="ifAlone!= null">
    <el-form-item style="float: right">
      <el-button @click="close" type="primary">返回</el-button>
    </el-form-item>
  </el-form>
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { ContactApi, ContactVO } from '@/api/supplier/contact'
import ContactForm from './ContactForm.vue'
import {SupplierVO} from "@/api/supplier/base";
import * as SupplierBaseApi from "@/api/supplier/base";
import * as SupplierDetailApi from "@/api/supplier/product/supplierdetail";
import { propTypes } from '@/utils/propTypes'
import {useTagsViewStore} from "@/store/modules/tagsView";
import {SupplierProductVo} from "@/api/supplier/product/supplierdetail";
const { delView } = useTagsViewStore() // 视图操作
const { push, currentRoute } = useRouter() // 路由
/** 供应商联系人 列表 */
defineOptions({ name: 'SupplierContact' })
const props = defineProps({
  isDetail: propTypes.bool.def(false), // 是否作为详情组件
  ifAlone: {type:Boolean, default:()=>null},
  receivedParam: { type: undefined, default: () => null }
})
const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化
const supplierList = ref([] as SupplierVO[])
const productList = ref([] as SupplierProductVo[])
const loading = ref(true) // 列表的加载中
const list = ref<ContactVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  supplierId: undefined,
  name: undefined,
  position: undefined,
  telephone: undefined,
  email: undefined,
  productIds: undefined,
  productNames: undefined,
  remark: undefined,
  createTime: [],
  supplierName: undefined,
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  supplierList.value = await SupplierBaseApi.Api.getAll()
  try {
    if (props.ifAlone!=null) {
      queryParams.supplierId = props.receivedParam === null?'0000000000':props.receivedParam
    }
    const data = await ContactApi.getContactPage(queryParams)
    list.value = data.list
    total.value = data.total
    queryParams.supplierId = undefined
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = async () => {
  queryParams.pageNo = 1
  await getList()
  supplierList.value = await SupplierBaseApi.Api.getAll()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await ContactApi.deleteContact(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await ContactApi.exportContact(queryParams)
    download.excel(data, '供应商联系人.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(async () => {
  await getList()
  supplierList.value = await SupplierBaseApi.Api.getAll()
  productList.value = await SupplierDetailApi.getAll()
})
const close = () => {
  delView(unref(currentRoute))
  push({ name: 'Suppliers',query: {
      date: new Date().getTime(),
    } })
}
</script>
